angular.module('starter', ['ionic'])
    .run(function($ionicPlatform) {
        $ionicPlatform.ready(function() {
            // All required scripts
            pages = new Pages();
            layout = new Layout();
            tap = new OnTap();

            if(window.StatusBar) {
                StatusBar.styleDefault();
            }
        });
    });

/***
 * Set storage (Array & Objects Supported!)
 * @param key
 * @param obj
 */
Storage.prototype.setObj = function(key, obj) {
    return this.setItem(key, JSON.stringify(obj))
}
Storage.prototype.getObj = function(key) {
    return JSON.parse(this.getItem(key))
}

// Remove this line if you don't want to reset the localstorage
// window.localStorage.clear();

/***
 * Configuration variables
 */
var paid = false;
var showInter = true;
var maxImages = 3;
var maxPercentage = 60;
var product;

/***
 * Google Admob
 * Notice: Select the right Ad Id according to platform
 * @type {{}}
 */
var admobid = {};
if( /(android)/i.test(navigator.userAgent) ) { // for android & amazon-fireos
    admobid = {
        banner: 'ca-app-pub-9902991356062122/6858685700', // or DFP format "/6253334/dfp_example_ad"
        interstitial: 'ca-app-pub-9902991356062122/8335418900'
    };
} else if(/(ipod|iphone|ipad)/i.test(navigator.userAgent)) { // for iOS
    admobid = {
        banner: 'ca-app-pub-9902991356062122/6858685700', // or DFP format "/6253334/dfp_example_ad"
        interstitial: 'ca-app-pub-9902991356062122/8335418900'
    };
} else {
    admobid = { // for Windows Phone
        banner: 'ca-app-pub-9902991356062122/6858685700', // or DFP format "/6253334/dfp_example_ad"
        interstitial: 'ca-app-pub-9902991356062122/8335418900'
    };
}

/***
 * Device (ready) listeners
 */
document.addEventListener("deviceready", onDeviceReady, false);
document.addEventListener("backbutton", onBackKeyDown, false);

function onDeviceReady() {
    /***
     * SETUP In-app Purchases
     * @type {number}
     */
    setupPurchases();

    /***
     * Google Analytics
     */
    window.ga.startTrackerWithId('UA-98739724-1', 0); // Tracker ID invullen
    window.ga.trackView('App Started tracker', '', true); // Tracker view
    window.ga.setAllowIDFACollection(true); // Interests collector (voor demografie)

    /***
     * Set output directory if user started the app for the first tiem
     */
    if(localStorage.getObj("outputDir") == "" || localStorage.getObj("outputDir") == null) localStorage.setObj("outputDir", "file:///storage/emulated/0/DCIM/Camera/");

    // Check for internet connection status.
    checkConnection(); // Uncomment this if required.
}

/***
 * Pressed on Back Key function
 * @param e
 */
function onBackKeyDown(e) {
    e.preventDefault();

    // Reset data
    selectedImages = [];

    if(layout.currentPage == pages.home_page) navigator.app.exitApp();
    layout.switchPage(pages.home_page);
    navigation.app.pauseOnExit(true);
}


/***
 * Check (type) internet connection
 */
function checkConnection() {
    // if( navigator.network.connection.type == Connection.NONE )
    // {
        // You can either choose to close the app if there is no internet connection
        // OR
        // You choose to show native ads of your own apps. FeelsSmartMan :)

        // alert("Couldn't connect to the internet. Internet connection is required to use the app.");
        // navigator.app.exitApp();
    // }

    if (navigator.network.connection.type == Connection.CELL_2G ||          // 2G Internet connection
        navigator.network.connection.type == Connection.CELL_3G ||          // 3G Internet connection
        navigator.network.connection.type == Connection.CELL_4G) {          // 4G Internet connection
        using_wifi = false;                                                 // Using Wifi is false, because mobile network provider connection is being used
    }
    else if( navigator.network.connection.type == Connection.WIFI )              // WiFi Internetion connection
    {
        using_wifi = true;                                                  // Using WiFi is true
        // if(randomIntFromInterval(1, 2) == 2) {
        // } 
    }

    // Loading ads
    if(!paid) loadAdmob();
}


/***
 * Toast (show little message function)
 * @param msg
 * @param duration
 * @param pos
 */
function toast(msg, duration, pos) {
    window.plugins.toast.showWithOptions(
        {
            message: msg,
            duration: duration, // which is 2000 ms. "long" is 4000. Or specify the nr of ms yourself.
            position: pos,
        }
    );
}

function AskForReview() {
    this.eachTime = 3; // Ask X time for a review. (Notice: counting goes from 0 in computer language). Standard after 3 times the user will be asked for a review.
    this.appStarted = localStorage.getObj("appStarted"); // Each time the app has started

    // console.log("Test: " + this.appStarted);

    if(this.appStarted == null && this.appStarted == "") {
        // If value doesn't exists we will create it right here
        localStorage.setObj("appStarted", 0);
    } else { // If user left a review before we don't ask for a review again
        if(this.appStarted == this.eachTime) { // If the app started X times equal to this.eachTime the app will ask for a review

            if(localStorage.getObj("stopRating") != true) {

                navigator.notification.confirm(
                    "Do you enjoy the app?",  // message
                    function(buttonIndex) {

                        if(buttonIndex == 1) { // If Yes (User is happy)
                            // Ask user for review
                            dialogRate();
                        } else { // If No (user is not happy)
                            localStorage.setObj("appStarted", 0);

                            // User doesn't like the app, so let's ask for feedback, so we can help.
                            navigator.notification.confirm(
                                "Would you mind giving us some feedback?",  // message
                                function(buttonIndex) {

                                    if(buttonIndex == 1) { // User pressed "Ok, sure"
                                        // Stop asking for rating
                                        localStorage.setObj("stopRating", true);

                                        // Open up the feedback form
                                        cordova.InAppBrowser.open('https://goo.gl/forms/ZxW1WaPPV6MDujNG2', '_blank', 'location=yes');
                                    } else {
                                        // User is not happy, stop asking for a review
                                        localStorage.setObj("stopRating", true);
                                    }

                                },                                       // callback
                                "Feedback",                              // title
                                ["Ok, sure", "No, thanks"]               // buttonName
                            );
                        }

                    },                                                   // callback
                    "Enjoying the app?",                                 // title
                    ["Yes", "Not really"]                               // buttonName
                );

            }

        } else { // Did the user not reach the value of this.eachTime? Then we will increase the value until the user has reached it
            // Increase value of appStarted
            localStorage.setObj("appStarted", ( this.appStarted + 1 ) );
        }
    }

    console.log(localStorage.getObj("appStarted"));

}

/***
 * Rate app dialog
 */
function dialogRate() {
    navigator.notification.confirm(
        "Would you mind to rate the app on Google Play?",  // message
        rateApp,                                           // callback
        "How about a rating on Google Play?",              // title
        ["Ok, sure", "No, thanks"]                         // buttonName
    );
}

/***
 * Buy IAP dialog
 */
function dialogBuy() {
    navigator.notification.confirm(
        "Become premium and unlock the following features: Reduce 10 images at once, Reduce to 80%!, Auto-save, NO advertisements and free future premium features.",  // message
        function(buttonIndex) {
            if(buttonIndex == 2) store.order(product.id);
        },                                // callback
        "Upgrade to Premium (50% SALE!)",            // title
        ["No, thanks", "Buy now"]                     // buttonName
    );
}

/***
 * Open Google Play function for: Rate app dialog function
 * @param buttonIndex
 */
function rateApp(buttonIndex) {
    // If user pressed "Ok, sure"
    if(buttonIndex == 1) {
        // Don't ask user again for review. We assume that the user will leave a review.
        localStorage.setObj("stopRating", true);

        // Open app page in Google Play
        cordova.plugins.market.open('com.tappuma.reduce.photo.size');
    } else {
        // Reset variable appStarted in local storage to 0
        localStorage.setObj("appStarted", 0);
    }
}

function setupPurchases() {
    // Let's set a pretty high verbosity level, so that we see a lot of stuff
    // in the console (reassuring us that something is happening).
    store.verbosity = store.INFO;

    /***
     * Register the product within the app.
     * ID = The product id WITHOUT the packagename!
     * Alias = Meant to be called within the app's code.
     * Type = Consumable, non-consumable or subscription
     */
    // We register a dummy product. It's ok, it shouldn't
    // prevent the store "ready" event from firing.

    // Premium User Lifetime
    store.register({
        id:    "3212989",
        alias: "premium user",
        type:  store.NON_CONSUMABLE
    });

    // Premium User Subscription
    store.register({
        id:    "premium_subscription",
        alias: "premium user sub",
        type:  store.NON_CONSUMABLE
    });

    /***
     * Log the error when something went wrong.
     */
    store.error(function(error) {
        console.log('ERROR ' + error.code + ': ' + error.message);
    });

    /***
     * Check if user owns product
     */
    store.when("premium user").owned(function() {
        // User owns product so unlock the premium features
        console.log("User owns the full version!");

        // User paid for full version
        paid = true;

        // Disable AdMob
        AdMob.hideBanner();
        showInter = false;

        // Make it available for the user to select 10 images
        maxImages = 10;

        // Set max percentage to 80
        maxPercentage = 80;

        // change appereance of home page for premium users
        $("#upgrade").remove();
        $(".action").css({'line-height': '22vh'});
        $(".action, .action-icon").css({'height': '22vh'});
        $(".action-icon").css({'width': '22vh'});
    });

    /***
     * Finish the order of the in-app purchase.
     */
    // When purchase of the full version is approved,
    // show some logs and finish the transaction.
    store.when("premium user").approved(function (order) {
        console.log('User unlocked full version!');

        // Finish the order
        order.finish();
    });

    /***
     * Unlock product when purchased.
     */
    store.when("premium version").updated(function (product) {
        navigator.notification.alert(
            'You unlocked the full version! Please restart the app to activate all new features!',  // message
            function() {},              // callback
            'Thank you for buying!',    // title
            'Continue'                  // buttonName
        );

        console.log("Amount of images that can be selected" + tap.maxImages);
    });

    // When every goes as expected, it's time to celebrate!
    // The "ready" event should be welcomed with music and fireworks,
    // go ask your boss about it! (just in case)
    store.ready(function() {
        console.log("\\o/ STORE READY \\o/");
    });

    // After we've done our setup, we tell the store to do
    // it's first refresh. Nothing will happen if we do not call store.refresh()
    store.refresh();

    /***
     * Update the product in the app when it's changed in the google dev console.
     */
    store.when("premium user").updated(function (p) {
        product = p;
    });

}

/***
 * Load Admob
 */
function loadAdmob() {
    /***
     * Prepare and load ad resource in background, e.g. at begining of game level
     */
    if (AdMob) {
        AdMob.prepareInterstitial({adId: admobid.interstitial, autoShow: false});

        /***
         * Create AdMob banner
         */
        AdMob.createBanner({
            adId : admobid.banner,
            position : AdMob.AD_POSITION.BOTTOM_CENTER,
            autoShow : true
        });
    }
}

/***
 * RenderIAP (Render in-app purchase)
 * @param p
 */
function renderIAP(p) {
    /***
     * Update the product in the app when it's changed in the google dev console.
     */
    store.when("premium user").updated(function (p) {
        product = p;
    });

    var parts = p.id.split(".");
    var elId = parts[parts.length-1];

    var el = document.getElementById(elId + '-purchase');
    if (!el) return;
    if (!p.loaded) {
        el.innerHTML = '<h3>...</h3>';
    }
    else if (!p.valid) {
        el.innerHTML = '<h3>' + p.alias + ' Invalid</h3>';
    }
    else if (p.valid) {
        var html;
        if (p.canPurchase) {
            var desc = p.description.split('-');
            // Old version
            // html = '<h4 class="p-title">' + p.title + '</h4><h4>Premium includes:</h4>' + '<ul><li>&bigstar;'+ desc[1] +'</li><li>&bigstar;'+ desc[2] +'</li><li>&bigstar;'+ desc[3] +'</li></ul>'; // var html = "<h3>" + p.title + "</h3>" + "<p>" + p.description + "</p>";
            // html += "<div class='button button-energized button-buy' id='buy-" + p.id + "' productId='" + p.id + "' type='button'>Buy now for only " + p.price + "</div>";

            html = '<ul class="iap-benefits">' +
                        '<li id="no-ads" class="icon">No advertisements</li>' +
                        '<li id="reduce-more" class="icon">Reduce 10 images at once instead of 3</li>' +
                        '<li id="auto-save" class="icon">Auto save: save all images at once</li>' +
                        '<li id="percentage" class="icon">No limits: Reduce to <b>80%</b> instead of 60%</li>' +
                        '<li id="tip" class="icon">Small tip for our hard work</li>' +
                    '</ul>';
            html += "<div class='button button-energized button-buy' id='buy-" + p.id + "' productId='" + p.id + "' type='button'>Buy now for " + p.price + "</div>";
        } else {
            html = '<h5 style="margin: 0 auto; text-align: center;">You own the full version (premium)!</h5>';
        }
        el.innerHTML = html;
        if (p.canPurchase) {
            document.getElementById("buy-" + p.id).onclick = function (event) {
                var pid = this.getAttribute("productId");

                // Order product
                store.order(pid);
            };
        }
    }


}

/***
 * Auto saves all images after reducing
 */
function showAutoSave() {
    if(paid) {
        if($("#autosave").length == 0) {
            $(".settingslist").append(
                '<label class="item item-checkbox item-checkbox-right checkbox-circle">' +
                '<div class="input-label">' +
                'Auto-save' +
                '</div>' +
                '<label class="checkbox">' +
                '<input type="checkbox" id="autosave">' +
                '</label>' +
                '</label>'
            );

            if(localStorage.getObj("autosave") == true) $("#autosave").prop('checked', true);
        }
    }
}

/***
 * Random int generator
 * @param min
 * @param max
 * @returns {number}
 */
function randomIntFromInterval(min,max)
{
    return Math.floor(Math.random()*(max-min+1)+min);
}
