function Layout() {
    this.currentPage = pages.home_page;

    // Setup the first page
    this.setup = function() {
        this.switchPage(this.currentPage);

        if(paid) {
            $(".action").css( { 'height': 22+'vh', 'line-height': 22+'vh' } );
            $(".action-icon").css( { 'width': 22+'vh', 'height': 22+'vh' } );
            $("#wrapper #upgrade").remove();
        };

        AskForReview();
    };

    this.switchPage = function(newpage) {
        // Check if element exists before removing components
        if($(".result").length > 0) {
            $(".result").remove();
            $(".compressed").remove();
            $(".original_preview").remove();
            $(".convertedTitle").remove();
        }

        if($("#backBtn").length == 0) $("#header .bar").append('<button id="backBtn" class="button">Back</button>');


        // Remove current page
        this.currentPage.remove();

        // Switch to new page
        switch(newpage) {
            case pages.home_page:
                $("#header .title").text("Choose a option");
                $("#wrapper").append(pages.home_page);

                if(paid) $("#upgrade").remove();

                // Remove back button
                if($("#backBtn").length > 0) $("#backBtn").remove();

                this.currentPage = pages.home_page;

                window.ga.trackView('Home page', '', true)
                break;
            case pages.reduce_page:
                $("#header .title").text("Reduce size");
                $("#wrapper").append(pages.reduce_page);

                $(".reduce_size").html('<input type="range" id="range" class="accelerateMe" oninput="rateOutputId.value = range.value" value="25" min="5" max="'+ maxPercentage +'">');

                // Check if controls are hidden, if so show them again.
                if( $(".controls").is(":hidden") ) $(".controls").show();

                this.currentPage = pages.reduce_page;

                window.ga.trackView('Reduce image page', '', true)
                break;
            case pages.resize_page:
                $("#header .title").text("Resize photo");
                $("#wrapper").append(pages.resize_page);

                // Check if controls are hidden, if so show them again.
                if( $(".controls").is(":hidden") ) $(".controls").show();

                this.currentPage = pages.resize_page;

                window.ga.trackView('Resize image page', '', true)
                break;
            case pages.crop_page:
                $("#header .title").text("Crop photo");
                $("#wrapper").append(pages.crop_page);

                this.currentPage = pages.crop_page;

                window.ga.trackView('Crop image page', '', true)
                break;
            case pages.convert_page:
                $("#header .title").text("Convert photo");
                $("#wrapper").append(pages.convert_page);

                // Check if controls are hidden, if so show them again.
                if( $(".controls").is(":hidden") ) $(".controls").show();

                this.currentPage = pages.convert_page;

                window.ga.trackView('Convert image page', '', true)
                break;
            case pages.settings_page:
                $("#header .title").text("Settings");
                $("#wrapper").append(pages.settings_page);

                // Make option from select "selected"
                if(localStorage.getObj("outputDir") != null) {
                    this.option = localStorage.getObj("outputDir");
                    $('.settings #select_output option[value="'+ this.option +'"]').attr('selected','selected');
                }

                // Load premium feature
                showAutoSave();

                this.currentPage = pages.settings_page;

                window.ga.trackView('Settings page', '', true)
                break;
            case pages.sales_page:
                $("#header .title").text("Upgrade");
                $("#wrapper").append(pages.sales_page);

                // Load in-app purchases
                renderIAP(product);

                this.currentPage = pages.sales_page;

                window.ga.trackView('In-app purchases page', '', true)
                break;
        }

    };

    /***
     * Setup homepage (IMPORTANT)
     */
    this.setup();
}
