// Global Array holding all selected images
var selectedImages;
var resultImages = {};

function OnTap() {
    // Back button
    $(document).on('touchend', '#backBtn', function() {
        layout.switchPage(pages.home_page);
    });

    // Rate app
    $(document).on('touchend', '.rate-app', function() {
        dialogRate();
    });

    // Sales/products page
    $(document).on('touchend', '#upgrade', function() {
        layout.switchPage(pages.sales_page);
    });

    // Settings page
    $(document).on('touchend', '#settingsBtn', function() {
        if(layout.currentPage == pages.reduce_page || layout.currentPage == pages.convert_page || layout.currentPage == pages.crop_page || layout.currentPage == pages.resize_page) {
            if($(".compressed").length > 0 || $(".converted").length > 0) { // Check if an image exists to see if the user is on a result page
                navigator.notification.confirm(
                    "If you go to the settings page now, you can't return to your results.",  // message
                    function(buttonIndex) { if(buttonIndex == 1) layout.switchPage(pages.settings_page); },  // callback
                    "Are you sure?",                                      // title
                    ["Yes", "No, not now"]                                // buttonName
                );
            } else {
                layout.switchPage(pages.settings_page);
            }
        } else {
            layout.switchPage(pages.settings_page);
        }
    });

    // OnChange output directory
    $(document).on('change', '#select_output', function() {
        // Set/save chosen output directory
        localStorage.setObj("outputDir", $(this).val());

        // Make option selected
        $('.settings #select_output option[value="'+ $(this).val() +'"]').attr('selected','selected');

        // Debug information
        console.log("Value: " + $(this).val());
    });

    $(document).on('change', '#autosave', function() {
        if(this.checked) localStorage.setObj("autosave", true);
        else localStorage.setObj("autosave", false);
    });

    $(document).on('touchend', '#resize', function() {
        // Load AdMob Interstitial
        if(showInter == true) AdMob.isInterstitialReady(function(ready){ if(ready){ AdMob.showInterstitial(); } });

        // Clear previous image results
        if(resultImages.length > 0) resultImages = {};

        window.imagePicker.getPictures(
            function(results) {
                // Switch to the page where images can be resized
                layout.switchPage(pages.resize_page);

                // Set results in variable selected images
                selectedImages = results;

                // Debug information: Log amount of selected images
                console.log("Amount of selected images: " + results.length);

                // If none images are selected then return to the home page
                if(results.length == 0) layout.switchPage(pages.home_page);

            }, function(error) {
                // Show dialog
                navigator.notification.alert(
                    'Something went wrong with retrieving the images. Please try again, if this bug stays please contact us at support@tappuma.com.',  // message
                    function() {},          // callback
                    'Something went wrong', // title
                    'Done'                  // buttonName
                );

                // Something went wrong here so the user will be redirected to the home/front page
                layout.switchPage(pages.home_page);

                console.log('Error: ' + error);
            }, {
                maximumImagesCount: maxImages
            }
        );
    });

    // Select dimension to resize too
    $(document).on('touchend', '#changeResolution', function() {
        toast("Resizing.. (this may take a while)", 60000, "bottom");

        for (var i = 0; i < selectedImages.length; i++) {

            window.resolveLocalFileSystemURL(selectedImages[i], function (fileEntry) {

                fileEntry.file(function (fileObject) {
                    // Create a reader to read the file
                    var reader = new FileReader();

                    // Create a function to process the file once it's read
                    reader.onloadend = function (evt) {
                        var img = new Image();

                        img.onload = function (evt) {
                            /// step 1
                            var oc = document.createElement('canvas'),
                                octx = oc.getContext('2d');

                            // Get user input
                            var resizeRate = $("#selectDimension").val(); // it's actually percentage
                            var resizeOption = $("#selectOption").val(); // this could be increase or decrease

                            // Rsize as in increase
                            if(resizeOption == "increase") {
                                oc.width = ( (img.width / 100) * resizeRate ) + img.width;
                                oc.height = ( (img.height / 100) * resizeRate ) + img.height;
                            } else if(resizeOption == "decrease") {
                                oc.width = img.width - ( ( img.width / 100 ) * resizeRate );
                                oc.height = img.height - ( ( img.height / 100 ) * resizeRate );
                            }

                            // console.log(img.width);
                            // console.log(img.height);
                            //
                            // console.log("Resize rate: " + resizeRate);

                            /// step 2
                            octx.drawImage(img, 0, 0, oc.width, oc.height);

                            var newImageData = oc.toDataURL("image/jpeg", 100);
                            var result_image_obj = new Image();
                            result_image_obj.src = newImageData;

                            // Add base64 encoded image to array
                            resultImages[i] = result_image_obj.src;

                            // Clear the controls because we don't need that anymore
                            $(".controls").hide();

                            // Append image to the page
                            $(".content").append(
                                '<div class="result">' +
                                '<h4 class="titleMe imageTitle' + i + '">New resolution ' + oc.width + 'x' + oc.height + '</h4>' +
                                '<img src="' + resultImages[i] + '" alt="image' + i + '" class="resized" id="image' + i + '">' +
                                '<div class="image_options">' +
                                '<p><a image="' + i + '" class="downloadImg dImg' + i + '"><button class="downloadBtn">Save image</button></a> <a image="' + i + '" class="shareImgBtn"><button class="shareBtn">Share</button></a></p>' +
                                '</div>' +
                                '</div>'
                            );

                            // This is a fix for a bug, I don't know why this works but if it works then let it be like this
                            i++;

                        }

                        window.plugins.toast.hide();
                        toast("Done!", 5000, "bottom");

                        // Set image source
                        img.src = evt.target.result;

                    }

                    // Read from disk the data as base64
                    reader.readAsDataURL(fileObject)

                }, function () {
                    toast("Something went wrong while resizing.. try again later.", 4000, "bottom");
                    console.log("There was an error reading or processing this file.")
                });

            });

        }

        // Debug information
        console.log("Dimension: " + $(this).val());

        // Load AdMob Interstitial
        if(showInter == true) AdMob.isInterstitialReady(function(ready){ if(ready){ AdMob.showInterstitial(); } });
    });

    $(document).on('touchend', '#crop', function() {
        // Clear previous image results
        if(resultImages.length > 0) resultImages = {};
        console.log(resultImages.length);
        console.log("Results: " + resultImages[0]);

        window.imagePicker.getPictures(
            function(results) {
                // Set results in variable selected images
                selectedImages = results;

                // Crop picture function
                Crop(results);

                // Debug information: Log amount of selected images
                console.log("Amount of selected images: " + results.length);

                // If none images are selected then return to the home page
                if(results.length == 0) layout.switchPage(pages.home_page);

            }, function(error) {
                // Show dialog
                navigator.notification.alert(
                    'Something went wrong with retrieving the images. Please try again, if this bug stays please contact us at support@tappuma.com.',  // message
                    function() {},          // callback
                    'Something went wrong', // title
                    'Done'                  // buttonName
                );

                // Something went wrong here so the user will be redirected to the home/front page
                layout.switchPage(pages.home_page);

                console.log('Error: ' + error);
            }, {
                maximumImagesCount: 1
            }
        );
    });

    $(document).on('touchend', '#convert', function() {
        // Load AdMob Interstitial
        if(showInter == true) AdMob.isInterstitialReady(function(ready){ if(ready){ AdMob.showInterstitial(); } });
        
        // Clear previous image results
        if(resultImages.length > 0) resultImages = {};

        window.imagePicker.getPictures(
            function(results) {
                // Switch to the page where images will be compressed!
                layout.switchPage(pages.convert_page);

                console.log("Amount of selected images: " + results.length);

                // Add images to array
                selectedImages = results;

                for (var i = 0; i < results.length; i++) {
                    console.log('Image URI: ' + results[i]);

                    // Preview images
                    $("#processedImages").append('<img src="'+ results[i] +'" id="image'+i+'" alt="image ' + i + '" />');
                }

                // If none images are selected then return to the home page
                if(results.length == 0) layout.switchPage(pages.home_page);

            }, function(error) {
                // Show dialog
                navigator.notification.alert(
                    'Something went wrong with retrieving the images. Please try again, if this bug stays please contact us at support@tappuma.com.',  // message
                    function() {},          // callback
                    'Something went wrong', // title
                    'Done'                  // buttonName
                );

                // Something went wrong here so the user will be redirected to the home/front page
                layout.switchPage(pages.home_page);

                console.log('Error: ' + error);
            }, {
                maximumImagesCount: maxImages
            }
        );
    });

    // Compress images
    $(document).on('mouseup touchend', '.compressBtn', function(e) {
        Reduce();
        e.preventDefault();
    });

    // Convert images
    $(document).on('mouseup touchend', '#convertImages', function(e) {
        Convert();
        e.preventDefault();
    });

    // Share image via apps
    $(document).on('mouseup touchend', '.shareImgBtn', function(e) {
        window.plugins.socialsharing.share(null,  Math.round(new Date().getTime() + (Math.random() * 100)), resultImages[ $(this).attr("image") ], null);
        e.preventDefault();
    });

    // Download compressed image button
    $(document).on('mouseup touchend', '.downloadImg', function(e) {
        /** Process the type1 base64 string **/
        // Eerst was het: $(this).attr("href")
        var myBaseString = resultImages[ $(this).attr("image") ];

        // Split the base64 string in data and contentType
        var block = myBaseString.split(";");
        // Get the content type
        var dataType = block[0].split(":")[1]; // In this case "image/png"
        // get the real base64 content of the file
        var realData = block[1].split(",")[1]; // In this case "iVBORw0KGg...."

        // The path where the file will be created
        var folderpath = localStorage.getObj("outputDir"); // "file:///storage/emulated/0/DCIM/Camera/";
        // The name of your file, note that you need to know if is .png,.jpeg etc
        var filename;

        if($("#select_extension").length == 0) filename = Math.round(new Date().getTime() + (Math.random() * 100)) + ".jpeg";
        else if($("#select_extension").length > 0) filename = Math.round(new Date().getTime() + (Math.random() * 100)) + "." + $("#select_extension").val();

        // Save image
        savebase64AsImageFile(folderpath, filename, realData, dataType);

        e.preventDefault();
    });

    // Select images for reduce process
    $(document).on('touchend', '#reduce', function() {
        // Load AdMob Interstitial
        if(showInter == true) AdMob.isInterstitialReady(function(ready){ if(ready){ AdMob.showInterstitial(); } });

        // Clear previous image results
        if(resultImages.length > 0) resultImages = {};

        window.imagePicker.getPictures(
            function(results) {
                // Switch to the page where images will be compressed!
                layout.switchPage(pages.reduce_page);

                console.log("Amount of selected images: " + results.length);

                // Add images to array
                selectedImages = results;

                // log selected images
                console.log("BEFORE " + selectedImages);

                for (var i = 0; i < results.length; i++) {
                    console.log('Image URI: ' + results[i]);

                    // Preview images
                    $(".preview_image").append('<img src="'+ results[i] +'" id="image'+i+'" class="original_preview" alt="image ' + i + '" />');
                }

                // If none images are selected then return to the home page
                if(results.length == 0) layout.switchPage(pages.home_page);

                if(showInter == true) AdMob.isInterstitialReady(function(ready){ if(ready){ AdMob.showInterstitial(); } });

            }, function(error) {
                // Show dialog
                navigator.notification.alert(
                    'Something went wrong with retrieving the images. Please try again, if this bug stays please contact us at support@tappuma.com.',  // message
                    function() {},          // callback
                    'Something went wrong', // title
                    'Done'                  // buttonName
                );

                // Something went wrong here so the user will be redirected to the home/front page
                layout.switchPage(pages.home_page);

                console.log('Error: ' + error);
            }, {
                maximumImagesCount: maxImages
            }
        );

    });

}

$(document).on('touchend', '.gif-creator', function() {
    cordova.plugins.market.open('com.gifcreator');
});

// Handle reduce/compress button function
function Reduce() {
    // Show loading toast
    toast("Compressing.. (this may take a while)", 60000, "bottom");

    // The final output format
    this.output_format = "jpg";

    // Retrieve image quality
    this.encodeQuality = $("#rateOutputId");

    this.quality = 100 - parseInt(this.encodeQuality.val());
    // console.log("Quality >>" + this.quality);

    // console.log("process start...");
    this.time_start = new Date().getTime();

    // console.log("Amount of selected images: " + selectedImages.length);

    // Clear the controls because we don't need that anymore
    $(".controls").hide();

    // Compressing all images & generating the required image elements for each compressed photo
    for(var i=0; i < selectedImages.length; i++) {
        // Creating source images (canvas images)
        this.source_image = document.getElementById("image" + i);

        // Insert compressed photo/result into the page
        this.result_image_source = jic.compress(this.source_image, this.quality, this.output_format).src;
        this.original_image_source = jic.compress(this.source_image, 100, this.output_format).src;

        // Add base64 encoded image to array
        resultImages[i] = this.result_image_source;

        $(".content").append(
            '<div class="result">' +
                '<h4 class="titleMe imageTitle'+i+'">Reduced from <b>'+ getImageSizeBase64(this.original_image_source) +'</b> > <b>' + getImageSizeBase64(this.result_image_source) + '</b></h4>' +
                '<div class="copyable">' +
                    '<img src="' + resultImages[i] + '" alt="image' + i + '" class="compressed" id="image' + i + '">' +
                '</div>' +
                '<div class="image_options">' +
                    '<p><a image="'+ i +'" class="downloadImg dImg'+ i +'"><button class="downloadBtn">Save image</button></a> <a image="'+ i +'" class="shareImgBtn"><button class="shareBtn">Share</button></a></p>' +
                '</div>' +
            '</div>'
        );

        window.resolveLocalFileSystemURL(this.source_image.src,
            function(fileEntry) {
                fileEntry.file(function(fileObj) {
                    original_size = Math.round(fileObj.size / 1000);
                    console.log("Size (kb) : " + original_size);
                    console.log("FOOTOOOOOOOO NUMMER : " + i);
                    console.log("FOTOOOOOOOOO CODE : " + this.result_image_source);
                });
            }
        );
        
        // Auto Save image if user paid for the feature (auto-save only available in the full version)
        if(localStorage.getObj("autosave") == true) autoSaveImage(this.result_image_source);

        // Debug information
        // console.log("Current image: image" + 1);
    }

    this.duration = new Date().getTime() - this.time_start;

    // Hide loading toast when done
    window.plugins.toast.hide();
    toast("Done!", 2500, "bottom");
    if(localStorage.getObj("autosave") == true) toast("All images are saved! You can disable auto-save in settings.", 12500, "bottom");

    console.log("process finished...");
    console.log('Processed in: ' + this.duration + 'ms');
    console.log("done!");

    // Load AdMob Interstitial
    if(showInter == true) AdMob.isInterstitialReady(function(ready){ if(ready){ AdMob.showInterstitial(); } });
}

// Function for converting images to another type of image (png, jpeg, gif, bmp)
function Convert() {
    // Show loading toast
    toast("Converting.. (this may take a while)", 60000, "bottom");

    // The final output format
    this.output_format = $("#select_extension").val();

    this.quality = 100;

    console.log("process start...");
    this.time_start = new Date().getTime();

    console.log("Amount of selected images: " + selectedImages.length);

    // Clear the controls because we don't need that anymore
    $(".controls").hide();

    // Show message that all images have been converted to the new extension that has been selected by the user
    // $(".content").append('<h4 class="convertedTitle titleMe">All images have been converted to '+ this.output_format +'</h4>');

    // Converting all selected images
    for(var i=0; i < selectedImages.length; i++) {
        // Selecting image(s)
        this.source_image = document.getElementById("image" + i);

        // Convert image to new output format (see: this.output_format)
        this.result_image_source = jic.compress(this.source_image, this.quality, this.output_format).src;

        // Add base64 encoded image to array
        resultImages[i] = this.result_image_source;

        // Debug information
        console.log(this.output_format);

        $(".content").append(
            '<div class="result">' +
                '<img src="' + resultImages[i] + '" alt="image' + i + '" class="converted" id="image' + i + '">' +
                '<div class="image_options">' +
                    '<p><a image="'+ i +'" class="downloadImg dImg'+ i +'"><button class="downloadBtn">Save image</button></a> <a image="'+ i +'" class="shareImgBtn"><button class="shareBtn">Share</button></a></p>' +
                '</div>' +
            '</div>'
        );

        // Debug information
        console.log("Current image: image" + 1);
    }

    // Clear image buffer
    $("#processedImages").empty();

    // Calculate process duration
    this.duration = new Date().getTime() - this.time_start;

    // Hide loading toast when done
    window.plugins.toast.hide();
    toast("All images have been converted to "+ this.output_format, 5000, "bottom");

    console.log("process finished...");
    console.log('Processed in: ' + this.duration + 'ms');
    console.log("done!");

    // Load AdMob Interstitial
    if(showInter == true) AdMob.isInterstitialReady(function(ready){ if(ready){ AdMob.showInterstitial(); } });
}

function Crop(results) {
    // Load AdMob Interstitial
    if(showInter == true) AdMob.isInterstitialReady(function(ready){ if(ready){ AdMob.showInterstitial(); } });

    // Crop the amount of selected images
    plugins.crop.promise(results[0])
        .then(function success(newPath) {
            // Switch to the page where images can be resized
            layout.switchPage(pages.crop_page);

            var img = new Image();

            img.onload = function() {
                // Log path of cropped image
                console.log(newPath);

                var oc = document.createElement('canvas'),
                    octx = oc.getContext('2d');

                oc.width = img.width;
                oc.height = img.height;

                octx.drawImage(img, 0, 0, oc.width, oc.height);

                var newImageData = oc.toDataURL("image/jpeg", 100);
                var result_image_obj = new Image();
                result_image_obj.src = newImageData;

                // Add base64 encoded image to array
                resultImages[0] = result_image_obj.src;

                // Log base64 encoded image
                // console.log(result_image_obj.src);

                $(".content").append(
                    '<div class="result">' +
                        '<h4 class="titleMe">Successful cropped!</h4>' +
                        '<img src="' + resultImages[0] + '" class="cropped" id="image0">' +
                        '<div class="image_options">' +
                            '<p><a image="0" class="downloadImg"><button class="downloadBtn">Save image</button></a> <a image="0" class="shareImgBtn"><button class="shareBtn">Share</button></a></p>' +
                        '</div>' +
                    '</div>'
                );
            }

            // Set source of image object
            img.src = newPath;

        })
        .catch(function fail(err) {
            console.log(err);
        });

    // Load AdMob Interstitial
    if(showInter == true) AdMob.isInterstitialReady(function(ready){ if(ready){ AdMob.showInterstitial(); } });
}

// Get photo size function
function getImageSizeBase64(imageUri) {
    this.head = "data:image/jpeg;base64,";

    this.imgSize = Math.round( ( imageUri.length - head.length ) * 3/4 );
    this.imgSize = Math.round( this.imgSize / 1000 );

    return this.imgSize + "kb";
}

function autoSaveImage(url) {
    /** Process the type1 base64 string **/
    var myBaseString = url;

    // Split the base64 string in data and contentType
    var block = myBaseString.split(";");
    // Get the content type
    var dataType = block[0].split(":")[1]; // In this case "image/png"
    // get the real base64 content of the file
    var realData = block[1].split(",")[1]; // In this case "iVBORw0KGg...."

    // The path where the file will be created
    var folderpath = localStorage.getObj("outputDir"); // "file:///storage/emulated/0/DCIM/Camera/";
    // The name of your file, note that you need to know if is .png,.jpeg etc
    var filename;

    if($("#select_extension").length == 0) filename = Math.round(new Date().getTime() + (Math.random() * 100)) + ".jpeg";
    else if($("#select_extension").length > 0) filename = Math.round(new Date().getTime() + (Math.random() * 100)) + "." + $("#select_extension").val();

    // Save image
    savebase64AsImageFile(folderpath, filename, realData, dataType);

    // Debug
    console.log("Image auto-saved. (Auto-save feature is enabled, disable if unwanted).");
}


/**
 * Convert a base64 string in a Blob according to the data and contentType.
 *
 * @param b64Data {String} Pure base64 string without contentType
 * @param contentType {String} the content type of the file i.e (image/jpeg - image/png - text/plain)
 * @param sliceSize {Int} SliceSize to process the byteCharacters
 * @return Blob
 */
function b64toBlob(b64Data, contentType, sliceSize) {
    contentType = contentType || '';
    sliceSize = sliceSize || 512;

    var byteCharacters = atob(b64Data);
    var byteArrays = [];

    for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
        var slice = byteCharacters.slice(offset, offset + sliceSize);

        var byteNumbers = new Array(slice.length);
        for (var i = 0; i < slice.length; i++) {
            byteNumbers[i] = slice.charCodeAt(i);
        }

        var byteArray = new Uint8Array(byteNumbers);

        byteArrays.push(byteArray);
    }

    var blob = new Blob(byteArrays, {type: contentType});
    return blob;
}

/**
 * Create a Image file according to its database64 content only.
 *
 * @param folderpath {String} The folder where the file will be created
 * @param filename {String} The name of the file that will be created
 * @param content {Base64 String} Important : The content can't contain the following string (data:image/png[or any other format];base64,). Only the base64 string is expected.
 */
function savebase64AsImageFile(folderpath,filename,content,contentType){
    // Convert the base64 string in a Blob
    var DataBlob = b64toBlob(content,contentType);

    console.log("Starting to write the file :3");

    window.resolveLocalFileSystemURL(folderpath, function(dir) {
        console.log("Access to the directory granted succesfully");
        dir.getFile(filename, {create:true}, function(file) {
            console.log("File created succesfully.");
            file.createWriter(function(fileWriter) {
                console.log("Writing content to file");
                fileWriter.write(DataBlob);

                if(folderpath == "file:///storage/emulated/0/") {
                    navigator.notification.alert(
                        'Your image is saved in your Root folder (Path: ' + localStorage.getObj("outputDir") + ')',  // message
                        function(){},               // callback
                        'Image saved!',             // title
                        'Done'                      // buttonName
                    );
                } else {
                    navigator.notification.alert(
                        'Your image is saved in: ' + localStorage.getObj("outputDir") + '',  // message
                        function(){},               // callback
                        'Image saved!',             // title
                        'Done'                      // buttonName
                    );                    
                }

                // Debug
                console.log("Image has been saved!");

            }, function(){
                alert('Unable to save image in path '+ folderpath);
            });
        });
    }, function() {
        // If selected path in settings doesn't exist, let's use Root as folder to store the image.
        savebase64AsImageFile("file:///storage/emulated/0/", filename, content, contentType);
    });
}
